
/*********************************************************************
* Copyright (c) 2018 Tecnalia.
*
* This program and the accompanying materials are made
* available under the terms of the Eclipse Public License 2.0
* which is available at https://www.eclipse.org/legal/epl-2.0/
*
* SPDX-License-Identifier: EPL-2.0
* Contributors (in alphabetical order):
* Alberto Molinuevo                         Tecnalia
* Gorka Benguria                            Tecnalia
* Iaki Etxaniz                             Tecnalia
* Juncal Alonso                             Tecnalia
* Leire Orue-Echevarria                     Tecnalia
* Maria Jose Lopez                          Tecnalia
* Marisa Escalante                          Tecnalia
* Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
**********************************************************************/
package eu.DECIDEh2020.optimus.editors;


import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Text;
import org.eclipse.wb.swt.SWTResourceManager;
//import org.eclipse.wb.swt.SWTResourceManager;
import org.json.simple.JSONArray;
//import org.json.simple.JSONException;
import org.json.simple.JSONObject;
//import org.json.parser.JSONParser;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import eu.DECIDEh2020.appManager.models.AppDescription;
import eu.DECIDEh2020.appManager.models.Microservice;
import eu.DECIDEh2020.architect.plugin.editor.Page;
import org.eclipse.swt.graphics.Point;

public class Classification extends Page {

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */

	/** The text widget used in page 2. */
	private StyledText text;
	/** The font chosen in page 1. */
	private Font font;
	private Text text_1;
	private Composite text_2;
	public int microservicesNumber = 0;

	public int y = 5;
	public String newcontent;
	private AppDescription appdescription;
	private Color background;


	
	public Classification(Composite parent, int style, AppDescription appdescription) {
		super(parent, SWT.NO_FOCUS, appdescription);
		this.appdescription = appdescription;
		background= SWTResourceManager.getColor(SWT.COLOR_WHITE);

		setBackground(background);
		createClassificationGUI(appdescription);
	}
		
	private void createClassificationGUI(AppDescription appdescription) {
		//to redraw the page/tab
		microservicesNumber = 0;
		y = 5;
		Control[] children = this.getChildren();
	    for (int i = 0 ; i < children.length; i++) {
	        children[i].dispose();
	    }
	    
	  
		Label lblAppName = new Label(this, SWT.RIGHT);
		lblAppName.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblAppName.setBounds(10, 10, 55, 20);
		lblAppName.setText("Multi-cloud Application name:");
		
		
		text_1 = new Text(this,SWT.BORDER);
		GridData gd_text_1 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_text_1.widthHint = 112;
		text_1.setLayoutData(gd_text_1);
		text_1.setBounds(10, 10, 100, 21);
		text_1.setText(appdescription.getName());
		
		setLayout(new GridLayout(2, true));
		Composite container  = new Composite(this, SWT.NONE);
		container.setLayoutData(new GridData(SWT.RIGHT, SWT.TOP, false, true, 2, 1));
		container.setBackground(background);
		GridLayout gl_container = new GridLayout(1,true);
		gl_container.horizontalSpacing = 10;
		container.setLayout(gl_container);
		
		ScrolledComposite scrolledComposite = new ScrolledComposite(container, SWT.V_SCROLL);
		  
		  Composite mcontainer = new Composite(scrolledComposite, SWT.NONE);
			mcontainer.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
			mcontainer.setLayout(new GridLayout(1, false));
			
		  
     	for (int i = 0; i <appdescription.getMicroservices().size(); i++)
    	
    	{
		microservicesNumber = microservicesNumber + 1;
		text_2 = new MicroserviceClassification(mcontainer, SWT.BORDER, y, appdescription, i);
     	
		text_2.setBounds(10, y, 600, 100);
		y = (120* microservicesNumber);
		
		}
     	mcontainer.requestLayout();
		
		scrolledComposite.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, true, 1, 1));
		scrolledComposite.setContent(mcontainer);
		scrolledComposite.setExpandVertical( true );
		scrolledComposite.setExpandHorizontal( true );
		int width = scrolledComposite.getClientArea().width/2;
		scrolledComposite.setMinSize( mcontainer.computeSize( width, SWT.DEFAULT ) );
		new Label(this, SWT.NONE);
		new Label(this, SWT.NONE);
		
		scrolledComposite.addListener( SWT.Resize, event -> {
			  final int w = scrolledComposite.getClientArea().width/2;
			  scrolledComposite.setMinSize( mcontainer.computeSize( w, SWT.DEFAULT ) );
			} );
     	

	}	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
	@Override
	public void open(AppDescription appd) {
		this.appdescription = appd;
		createClassificationGUI(appd);
		
	}
}
