
/*********************************************************************
* Copyright (c) 2018 Tecnalia.
*
* This program and the accompanying materials are made
* available under the terms of the Eclipse Public License 2.0
* which is available at https://www.eclipse.org/legal/epl-2.0/
*
* SPDX-License-Identifier: EPL-2.0
* Contributors (in alphabetical order):
* Alberto Molinuevo                         Tecnalia
* Gorka Benguria                            Tecnalia
* Iaki Etxaniz                             Tecnalia
* Juncal Alonso                             Tecnalia
* Leire Orue-Echevarria                     Tecnalia
* Maria Jose Lopez                          Tecnalia
* Marisa Escalante                          Tecnalia
* Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
**********************************************************************/
package eu.DECIDEh2020.optimus.editors;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

import eu.DECIDEh2020.appManager.models.Microservice;
import eu.DECIDEh2020.appManager.AppDescriptionHelper;
import eu.DECIDEh2020.appManager.models.AppDescription;
import eu.DECIDEh2020.appManager.models.DetachableResource;
import org.eclipse.swt.custom.ScrolledComposite;


public class MicroserviceClassification extends Composite {

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	/** The text widget used in page 2. */
	private StyledText text;
	/** The font chosen in page 1. */
	private Font font;
	private Text text_1;
	private Text text_2;
	private static JSONObject micros;
	private Text Detach_text;
	private AppDescription appdescription;
	private String DRes_type;

	
	public MicroserviceClassification(Composite parent, int style, int y, AppDescription appdescription, int i) {
		super(parent, style);
		setEnabled(true);
		this.appdescription = appdescription;
		
		if (appdescription.getMicroservices().get(i).getDetachableResources().isEmpty())
			
		{	DetachableResource DR = new DetachableResource();
			DR.setName("none");
			DR.setId(UUID.randomUUID().toString());
			appdescription.getMicroservices().get(i).getDetachableResources().add(0, DR);
		}
			Label lblMicroserviceName = new Label(this, SWT.NONE);
			lblMicroserviceName.setBounds(10, 13, 50, 30);
			lblMicroserviceName.setText("Name");
			Text text_2 = new Text(this, SWT.BORDER);
			text_2.setTouchEnabled(true);
			text_2.setEnabled(true);
			text_2.setBounds(69, 13, 228, 30);
			text_2.setText(appdescription.getMicroservices().get(i).getName());
			
			Label microserviceID = new Label(this, SWT.NONE);
			microserviceID.setBounds(275, 13, 50, 15);
			microserviceID.setVisible(false);
			microserviceID.setText(appdescription.getMicroservices().get(i).getId());
			
			
			
			Combo ms_type = new Combo(this, SWT.NONE);
			ms_type.setTouchEnabled(true);
			ms_type.setEnabled(true);
			ms_type.setItems(new String[] {"Computing", "Computing Public IP"});
			ms_type.setBounds(505, 13, 190, 28);
			
			//take from appdescription the ms_type
			String mstype = appdescription.getMicroservices().get(i).getClassification();
			if (mstype != null)
			{
				ms_type.setText(mstype);
				if (mstype.contentEquals("Computing Public IP"))
				{
				appdescription.getMicroservices().get(i).setPublicIP(true);
				}
			}
			else 
			{
			appdescription.getMicroservices().get(i).setClassification("Computing");
			ms_type.setText("Computing");
			}
						
			ms_type.addFocusListener(new FocusListener() {

				
				@Override
				public void focusGained(FocusEvent arg0) {
					
				}

				@Override
				public void focusLost(FocusEvent arg0) {
					appdescription.getMicroservices().get(i).setClassification(ms_type.getText());
				}
				
				
			});
			
			
			Label lblDetachableResource = new Label(this, SWT.NONE);
			lblDetachableResource.setBounds(11, 53, 163, 27);
			lblDetachableResource.setText("Detachable Resource");
			Detach_text = new Text(this, SWT.BORDER);
			Detach_text.setText("none");
			Detach_text.setTouchEnabled(true);
			Detach_text.setEnabled(true);
			Detach_text.setBounds(180, 50, 117, 30);
			String DRname = appdescription.getMicroservices().get(i).getDetachableResources().get(0).getName();
			//if (DRname != "none")
			if (!DRname.contains("none"))
							
			{	
				Detach_text.setText(DRname);
			}
			
			Detach_text.addFocusListener(new FocusListener(){
		    	

				@Override
				public void focusGained(FocusEvent arg0) {
					
				}

				@Override
				public void focusLost(FocusEvent arg0) {
					String name = Detach_text.getText();
						appdescription.getMicroservices().get(i).getDetachableResources().get(0).setName(name);
						appdescription.getMicroservices().get(i).getDetachableResources().get(0).setId(UUID.randomUUID().toString());
				}
			});
						
			Combo Detach_type = new Combo(this, SWT.NONE);
			Detach_type.setTouchEnabled(true);
			Detach_type.setEnabled(true);
			Detach_type.setItems(new String[] {"db", "storage", "queue system"});
			Detach_type.setBounds(505, 53, 190, 28);
			
			String DRtype = appdescription.getMicroservices().get(i).getDetachableResources().get(0).getClassification();
			
			if (DRname.contains("none"))
			{
				Detach_type.setText("storage");
				appdescription.getMicroservices().get(i).getDetachableResources().get(0).setClassification("storage");
			}
			
			else
			{
				Detach_type.setText(appdescription.getMicroservices().get(i).getDetachableResources().get(0).getClassification());
			}
			
			Detach_type.addFocusListener(new FocusListener(){
		    	

				@Override
				public void focusGained(FocusEvent arg0) {
					
				}

				@Override
				public void focusLost(FocusEvent arg0) {
					String type = Detach_type.getText();
						appdescription.getMicroservices().get(i).getDetachableResources().get(0).setClassification(type);
				}
			});
			Button Det_DB = new Button(this, SWT.RADIO);
			Det_DB.setSelection(false);
			Det_DB.setBounds(303, 55, 43, 21);
			Det_DB.setText("DB");
				DetachableResource detdet = new DetachableResource();
				detdet = appdescription.getMicroservices().get(i).getDetachableResources().get(0);
				String name = detdet.getName();
				
				//detdet.setDb(true);
				Boolean isdb =  detdet.isDb();
				Det_DB.setSelection(isdb);
				
				Label lblMsclassification = new Label(this, SWT.NONE);
				lblMsclassification.setBounds(363, 13, 136, 30);
				lblMsclassification.setText("MSClassification:");
				
				Label lblDrclassification = new Label(this, SWT.NONE);
				lblDrclassification.setBounds(363, 53, 136, 28);
				lblDrclassification.setText("DRClassification:");
			
			Det_DB.addFocusListener(new FocusListener(){
		    	

				public void focusGained(FocusEvent arg0) {
					
						
					
				}
				public void focusLost(FocusEvent arg0) {
					//appdescription.getMicroservices().get(i).getDetachableResources().get(0).setDb(false);
					
					if (Det_DB.getSelection()) {
						if (appdescription.getMicroservices().get(i).getDetachableResources().get(0).isDb()) {
							appdescription.getMicroservices().get(i).getDetachableResources().get(0).setDb(false);
						appdescription.getMicroservices().get(i).getDetachableResources().get(0).setSql(false);
						Detach_type.setText("storage");
						Det_DB.setSelection(false);
						}
						else {
							Det_DB.setSelection(true);
							appdescription.getMicroservices().get(i).getDetachableResources().get(0).setDb(true);
							Detach_type.setText("db");
							if (appdescription.getMicroservices().get(i).getDetachableResources().get(0).getName().equals("MySQL")) {
								appdescription.getMicroservices().get(i).getDetachableResources().get(0).setSql(true);
								}
						}
						DRes_type="db";
//						if (appdescription.getMicroservices().get(i).getDetachableResources().get(0).getName().equals("MySQL")) {
//						appdescription.getMicroservices().get(i).getDetachableResources().get(0).setSql(true);
//						}
						//appdescription.getMicroservices().get(i).getDetachableResources().get(0).setDb(true);
						//Detach_type.setText("db");
						//Det_DB.setSelection(true);

											} 
//					else {
//						appdescription.getMicroservices().get(i).getDetachableResources().get(0).setSql(false);
//						Det_DB.setSelection(true);
//						DRes_type="db";
//						if (appdescription.getMicroservices().get(i).getDetachableResources().get(0).getName().equals("MySQL")) {
//						appdescription.getMicroservices().get(i).getDetachableResources().get(0).setSql(true);
//						}
//					}
					if (!Det_DB.getSelection() && !appdescription.getMicroservices().get(i).getDetachableResources().get(0).getClassification().contains("System Queue") ) {
						Detach_type.setText("storage");
						DRes_type="storage";
						Det_DB.setSelection(false);
						
						}
					
						appdescription.getMicroservices().get(i).getDetachableResources().get(0).setClassification(DRes_type);
				}
			}
					);

		}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
