package eu.decideh2020.optimus.server.api;

import eu.decideh2020.optimus.server.model.*;
import eu.decideh2020.optimus.server.api.ApplicationsApiService;
import eu.decideh2020.optimus.server.api.factories.ApplicationsApiServiceFactory;

import io.swagger.annotations.ApiParam;
import io.swagger.jaxrs.*;

import eu.decideh2020.optimus.server.model.ReturnedSc;
import eu.decideh2020.optimus.server.model.ReturnedSimulation;
import eu.decideh2020.optimus.server.model.Simulation;

import java.util.Map;
import java.util.List;
import eu.decideh2020.optimus.server.api.NotFoundException;

import java.io.InputStream;

import org.glassfish.jersey.media.multipart.FormDataContentDisposition;
import org.glassfish.jersey.media.multipart.FormDataParam;

import javax.servlet.ServletConfig;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.SecurityContext;
import javax.ws.rs.*;
import javax.validation.constraints.*;

@Path("/applications")


@io.swagger.annotations.Api(description = "the applications API")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaJerseyServerCodegen", date = "2018-11-16T06:47:28.986Z")
public class ApplicationsApi  {
   private final ApplicationsApiService delegate;

   public ApplicationsApi(@Context ServletConfig servletContext) {
      ApplicationsApiService delegate = null;

      if (servletContext != null) {
         String implClass = servletContext.getInitParameter("ApplicationsApi.implementation");
         if (implClass != null && !"".equals(implClass.trim())) {
            try {
               delegate = (ApplicationsApiService) Class.forName(implClass).newInstance();
            } catch (Exception e) {
               throw new RuntimeException(e);
            }
         } 
      }

      if (delegate == null) {
         delegate = ApplicationsApiServiceFactory.getApplicationsApi();
      }

      this.delegate = delegate;
   }

    @POST
    
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "createsSimulation", notes = "Creates a trigeredSimulation", response = ReturnedSimulation.class, responseContainer = "List", tags={  })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "simulation created", response = ReturnedSimulation.class, responseContainer = "List"),
        
        @io.swagger.annotations.ApiResponse(code = 401, message = "Unauthorized", response = String.class),
        
        @io.swagger.annotations.ApiResponse(code = 403, message = "Forbidden", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 404, message = "Not Found", response = Void.class) })
    public Response createsSimulationUsingPOST(@ApiParam(value = "" ,required=true) Simulation simulation
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.createsSimulationUsingPOST(simulation,securityContext);
    }
    @DELETE
    @Path("/delete/{simid}")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "deleteSimulation", notes = "", response = Void.class, tags={  })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "OK", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 204, message = "No Content", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 401, message = "Unauthorized", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 403, message = "Forbidden", response = Void.class) })
    public Response deleteASimulationUsingDELETE(@ApiParam(value = "readable format of the id of one specific simulation",required=true) @PathParam("simid") Integer simid
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.deleteASimulationUsingDELETE(simid,securityContext);
    }
    @GET
    
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "getAllSimulations", notes = "Gets the list of the triggered simulations registered , including the id and the status of the simulation. The simid would be an readble identification, build with the information about the application", response = ReturnedSimulation.class, responseContainer = "List", tags={  })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "the simulation being returned", response = ReturnedSimulation.class, responseContainer = "List"),
        
        @io.swagger.annotations.ApiResponse(code = 401, message = "Unauthorized", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 403, message = "Forbidden", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 404, message = "Not Found", response = Void.class) })
    public Response getAllSimulationsUsingGET(@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.getAllSimulationsUsingGET(securityContext);
    }
    @GET
    @Path("/schema/{simid}")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "getSchema", notes = "Gets the schema", response = ReturnedSc.class, responseContainer = "List", tags={  })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "the schema being returned", response = ReturnedSc.class, responseContainer = "List"),
        
        @io.swagger.annotations.ApiResponse(code = 401, message = "Unauthorized", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 403, message = "Forbidden", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 404, message = "Not Found", response = Void.class) })
    public Response getSchemaUsingGET(@ApiParam(value = "readable format of the id of one specific simulation",required=true) @PathParam("simid") Integer simid
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.getSchemaUsingGET(simid,securityContext);
    }
    @GET
    @Path("/{simid}")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "getSimulation", notes = "", response = ReturnedSimulation.class, responseContainer = "List", tags={  })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "the specific simulation being returned", response = ReturnedSimulation.class, responseContainer = "List"),
        
        @io.swagger.annotations.ApiResponse(code = 401, message = "Unauthorized", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 403, message = "Forbidden", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 404, message = "Not Found", response = Void.class) })
    public Response getSimulationUsingGET(@ApiParam(value = "readable format of the id of one specific simulation",required=true) @PathParam("simid") Integer simid
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.getSimulationUsingGET(simid,securityContext);
    }
}
