/*********************************************************************
* Copyright (c) 2018 Tecnalia.
*
* This program and the accompanying materials are made
* available under the terms of the Eclipse Public License 2.0
* which is available at https://www.eclipse.org/legal/epl-2.0/
*
* SPDX-License-Identifier: EPL-2.0
* Contributors (in alphabetical order):
* Alberto Molinuevo                         Tecnalia
* Gorka Benguria                            Tecnalia
* Iñaki Etxaniz                             Tecnalia
* Juncal Alonso                             Tecnalia
* Leire Orue-Echevarria                     Tecnalia
* Maria Jose Lopez                          Tecnalia
* Marisa Escalante                          Tecnalia
* Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
**********************************************************************/
package eu.decideh2020.optimus.server.model;

import java.util.ArrayList;
import java.util.List;

import eu.DECIDEh2020.appManager.models.Microservice;
import eu.DECIDEh2020.appManager.models.SchemaElement;

public class sortingPossibilities {
	
	
	     
	    private List<msANDcs> array;
	    private int length;
	 
	    public void sort(List<msANDcs> inputArr) {
	         
	        if (inputArr == null || inputArr.size() == 0) {
	            return;
	        }
	        this.array = inputArr;
	        length = inputArr.size();
	        quickSort(0, length - 1);
	    }
	 
	    private void quickSort(int lowerIndex, int higherIndex) {
	         
	        int i = lowerIndex;
	        int j = higherIndex;
	        // calculate pivot number, I am taking pivot as middle index number
	        double pivot = array.get(lowerIndex+(higherIndex-lowerIndex)/2).getWeight();
	        //int pivot = array[lowerIndex+(higherIndex-lowerIndex)/2];
	        // Divide into two arrays
	        while (i <= j) {
	            /**
	             * In each iteration, we will identify a number from left side which 
	             * is greater then the pivot value, and also we will identify a number 
	             * from right side which is less then the pivot value. Once the search 
	             * is done, then we exchange both numbers.
	             */
	            //System.out.println(array.get(i).getWeight());
	            //System.out.println(pivot);

	        	while (array.get(i).getWeight() > pivot) {
	                i++;
	            }
	            while (array.get(j).getWeight() < pivot) {
	                j--;
	            }
	            if (i <= j) {
	                exchangeNumbers(i, j);
	                //move index to next position on both sides
	                i++;
	                j--;
	            }
	        }
	        // call quickSort() method recursively
	        if (lowerIndex < j)
	            quickSort(lowerIndex, j);
	        if (i < higherIndex)
	            quickSort(i, higherIndex);
	    }
	 
	    private void exchangeNumbers(int i, int j) {
	        msANDcs temp = array.get(i);
	        array.set(i, array.get(j));
	        array.set(j, temp);
	    }
	    
	    public List<SchemaElement> combine(List<msANDcs> inputArr) {
	    	List<SchemaElement> sc = new ArrayList<>();
	        if (inputArr == null || inputArr.size() == 0) {
	            return sc;
	        }
	        this.array = inputArr;
	        length = inputArr.size();
	        List<String> micros = new ArrayList<>();
	        int i=0;
	        
	        for (msANDcs mscs : array) {
	        	//mscs is a sorted list, the first row you find for a microservice id is the best one
	        	
	        	SchemaElement newsc = new SchemaElement();
        		List<String> microservices = new ArrayList<>();
        		
	        	if (!micros.contains(mscs.getMsid())){
	        		newsc.setIndex(i);
        			newsc.setCsId(mscs.getCsid());
        			microservices.add(mscs.getMsid());	
        			//for now just one detachable resource associated to one microservice
        			microservices.add(mscs.getdrid().get(0));
        			newsc.setMicroservices(microservices);
        			sc.add(newsc);
        			micros.addAll(microservices);
	        	}
       	
	        }
	        i=0;	
	        List<SchemaElement> scfinal = new ArrayList<>();
	        int index;
	        for (SchemaElement scaux : sc) {
	        	SchemaElement scfinalelement = new SchemaElement();
	        	index = included(scaux.getCsId(),scfinal);
	        	if (index != 9999) {
	        		//scfinalelement.getMicroservices().add(scaux.getMicroservices().get(0));
	        		scfinal.get(index).getMicroservices().addAll(scaux.getMicroservices());
	        		
	        	}
	        	else {
	        		scfinalelement.setCsId(scaux.getCsId());
	        		scfinalelement.setIndex(i);
	        		scfinalelement.setMicroservices(scaux.getMicroservices());
	        		scfinal.add(scfinalelement);
	        		i++;
	        	}
	        	
			}
	        
	        return scfinal;
	    }

		private int included(String csId, List<SchemaElement> scfinal) {
			int indexincluded=9999;
			 for (SchemaElement sc : scfinal) {
				 if (sc.getCsId().equals(csId)){
					 indexincluded = sc.getIndex();
				 } 

		}
			 return indexincluded;
}
		
}   
	

