/*********************************************************************
* Copyright (c) 2018 Tecnalia.
*
* This program and the accompanying materials are made
* available under the terms of the Eclipse Public License 2.0
* which is available at https://www.eclipse.org/legal/epl-2.0/
*
* SPDX-License-Identifier: EPL-2.0
* Contributors (in alphabetical order):
* Alberto Molinuevo                         Tecnalia
* Gorka Benguria                            Tecnalia
* Iñaki Etxaniz                             Tecnalia
* Juncal Alonso                             Tecnalia
* Leire Orue-Echevarria                     Tecnalia
* Maria Jose Lopez                          Tecnalia
* Marisa Escalante                          Tecnalia
* Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
**********************************************************************/
package eu.decideh2020.optimus.server.api.impl;

import java.util.ArrayList;
import java.util.Random;
import eu.decideh2020.optimus.server.api.*;
import eu.decideh2020.optimus.server.model.*;

import javax.ws.rs.core.Response;
import javax.ws.rs.core.SecurityContext;
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaJerseyServerCodegen", date = "2018-03-06T15:32:29.649Z")
public class ApplicationsApiServiceImpl extends ApplicationsApiService {
	
	ArrayList<Simulation> SimsLaunched = new ArrayList<Simulation>();
	SimQueue SimQ = SimQueue.getInstance( );
	
    @Override
    public Response createsSimulationUsingPOST(Simulation simulation, SecurityContext securityContext) throws NotFoundException {
        
    	SimQueue SimQ = SimQueue.getInstance( );
    	//Simulation currentsim = simulation;
    	Simulation simlaunch = new Simulation();
    	int simid = Math.abs((new Random()).nextInt()); 
    	simlaunch.setSimid(simid);
    	//currentsim.isCorrect(currentsim);
    	//some method to validate the data and returning ok or not Ok.
    	// where has to be placed this method? in Simulation class for now.
    	simlaunch.setStatus("started");
    	simlaunch.setAppurl(simulation.getAppurl());
    	SimsLaunched.add(simlaunch);
    	SimQ.add(simlaunch);
     	//System.out.println(simlaunch.getAppurl());
		ReturnedSimulation returnedsimulation = new ReturnedSimulation();
		returnedsimulation.setSimid(simlaunch.getSimid());
		returnedsimulation.setStatus(simlaunch.getStatus());

		ArrayList<ReturnedSimulation> simsreturned = new ArrayList<ReturnedSimulation>();
		simsreturned.add(returnedsimulation);

//		ObjectMapper mapper = new ObjectMapper();
//    	//Object to JSON in file
//    	//Object to JSON in String
//		String jsonInString = "";
//		try {
//			jsonInString = mapper.writeValueAsString(simsreturned);
//		} catch (JsonProcessingException e) {
//	// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
		//System.out.println("jsonstring"+jsonInString);
        //return Response.ok().entity(new ApiResponseMessage(ApiResponseMessage.OK, jsonInString)).build();
		//Change the way swagger generates the response, because a simpler build works
		return Response.ok().entity(simsreturned).build();
    }
    @Override
    public Response getAllSimulationsUsingGET(SecurityContext securityContext) throws NotFoundException {
        // do some magic!
    	SimQueue SimQ = SimQueue.getInstance( );
    	ArrayList<ReturnedSimulation> SimsReturned = new ArrayList<ReturnedSimulation>();
    	
// I do not build the response with ReturnedSimulation objects because of the format that they are shown in swagger, but I should be aware
    	// of the kind of object that is going to need every tool who asks for these REST services.
    	for (int i=0;i<SimQ.size();i++)
    	{
    	
    		Simulation simselected = new Simulation();
    		ReturnedSimulation simret = new ReturnedSimulation();
        	ArrayList<ReturnedSimulation> simsreturned = new ArrayList<ReturnedSimulation>();
        	
    			simselected = SimQ.element();
    			if (simselected!=null ) {
    				simret.setSimid(simselected.getSimid());
    				simret.setStatus(simselected.getStatus());
    				//simret.setSc(simselected.getSc());
    				
    			
    			
    		}
        	simsreturned.add(simret);
}
//    	{	//ReturnedSimulation simselected = new ReturnedSimulation();
//    		//simselected.setSimid(SimsLaunched.get(i).getSimid());
//    		//simselected.setStatus(SimsLaunched.get(i).getStatus());
//    		simselected.setStatus(SimsLaunched.get(i).getStatus());
//    		simselected.setSimid(SimsLaunched.get(i).getSimid());
//    		SimsReturned.add(simselected);
//    		}
    	//GenericEntity<List<ReturnedSimulation>> aux = new GenericEntity<List<ReturnedSimulation>>(Lists.newArrayList(SimsReturned)) {};
    			
        return Response.ok().entity(SimsReturned).build();
    }
    

    @Override
    public Response getSchemaUsingGET(Integer simid, SecurityContext securityContext) throws NotFoundException {
        // do some magic!

		ReturnedSc simret = new ReturnedSc();
    	ArrayList<ReturnedSc> schreturned = new ArrayList<ReturnedSc>();
    	for (Simulation simselected : SimsLaunched) {
    	
    	//while (true) {
			
			if (simselected!=null && simselected.getSimid().equals(simid)) {
				//simret.setSimid(simid);
				//simret.setStatus(simselected.getStatus());
				//for
				for (ReturnedSc scret : simselected.getSc()) {
					
					schreturned.add(scret);
					}
				break;
			}
			
		}
    	
        return Response.ok().entity(schreturned).build();
    }
	@Override
	public Response deleteASimulationUsingDELETE(Integer simid, SecurityContext securityContext)
			throws NotFoundException {
        // do some magic!
    	SimsLaunched.remove(SimsLaunched.get(simid));
        return Response.ok().entity("Removed Simulation "+simid).build();
	}
	@Override
	public Response getSimulationUsingGET(Integer simid, SecurityContext securityContext) throws NotFoundException {
			//SimQueue SimQ = SimQueue.getInstance( );
		ReturnedSimulation simret = new ReturnedSimulation();
    	ArrayList<ReturnedSimulation> simsreturned = new ArrayList<ReturnedSimulation>();
    	for (Simulation simselected : SimsLaunched) {
    	
    	//while (true) {
			
			if (simselected!=null && simselected.getSimid().equals(simid)) {
				simret.setSimid(simid);
				simret.setStatus(simselected.getStatus());
				//simret.setSc(simselected.getSc());
				break;
			}
			
		}
    	simsreturned.add(simret);
		
//    	for (int i=0;i<SimsLaunched.size();i++)
//    	{
//
//    		if (SimsLaunched.get(i).getSimid() == simid)
//    		{
//    		simselected.setStatus(SimsLaunched.get(i).getStatus());
//    		simselected.setSimid(simid);
//    		simsreturned.add(simselected);
//    			break;
//    		}
//    			}
        return Response.ok().entity(simsreturned).build();
	}
	

}
